---
title: XRSession.oninputsourceschange
slug: Web/API/XRSession/oninputsourceschange
tags:
  - API
  - AR
  - Augmented Reality
  - Event Handler
  - Experimental
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XR
  - oninputsourceschange
---
<div>{{draft}}{{securecontext_header}}{{APIRef("WebXR")}}</div>

<p><span class="seoSummary">The <code><strong>oninputsourcechange</strong></code> attribute of the {{DOMxRef("XRSession")}} object is the event handler for the {{DOMxRef("XRSession.inputsourcechange_event", "inputsourcechange")}} event, which is dispatched when session's list of active XR input sources has changed. The list itself is accessible via {{DOMxRef("XRSession.inputSources")}}.</span></p>

<div class="notecard note">
<p><strong>Note:</strong> The {{DOMxRef("XRInputSource")}} objects in {{DOMxRef("XRSession.inputSources")}} array are "live", so values within them are updated in-place. Therefore if you wish to compare input states between frames, you should make a copy of the content of the state in question.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js"><em>XRSession</em>.oninputsourceschange = function(event) { ... }
</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js"><em>XRSession</em>.oninputsourceschange = function(event) {
  console.log("The list of active XR input sources has changed.")
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-oninputsourceschange","XRSession.oninputsourceschange")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRSession.oninputsourceschange")}}</p>

<h2 id="See_also">See also</h2>

<p>{{DOMxRef("XRSession.inputSources")}}</p>
